clear all
clc
close all

n=input('Introduci il grado del polinomio: g=');
int=input('Introduci l''intervallo [a,b]: ');
a=int(1);
b=int(2);

%ascisse punti di interpolazione
scelta_x=menu('Scegli le ascisse dei punti di interpolazione','Equidistanti','Zeri Chebychev','Fine');
switch scelta_x
    case 1
         x=linspace(a,b,n+1);
        
    case 2
         for i=1:n+1
             x(i)=(a+b)/2-(b-a)/2*cos((2*(i-1)+1)*pi/(2*(n+1)));
         end
    
    otherwise
        close all;
        return;
end

%punti di valutazione
xv=linspace(a,b,100);

%ordinate punti di interpolazione
scelta_y=menu('Scegli le ordinate dei punti di interpolazione','Seno','Runge','Fine');
switch scelta_y
    case 1
         y=fun1(x);
         f=fun1(xv);
        
    case 2
         y=funRunge(x);
         f=funRunge(xv);
         
    otherwise
        close all;
        return;
end

%interpolazione col metodo di Newton
c=InterpN(x,y);
yv1=HornerN(c,x,xv);
         
%interpolazione spline         
yv2=spline(x,y,xv);
        
plot(x,y,'r*',xv,yv1,'b-',xv,yv2,'g-',xv,f,'r-');
legend('Punti di interpolazione','Interpolante di Newton','Interpolante spline','Funzione test');
